# PDFlib PLOP DS:
# Encrypt file with certificate security.

from sys import *
from traceback import print_tb
from PDFlib.PLOP import *

# This is where input files live. Adjust as necessary.
searchpath = "../data"

recipients_cert = [
    # no permission restrictions
    "../data/demo_recipient_1.pem",
    # form filling and signing permissions granted, but not others
    "../data/demo_recipient_2.pem",
    "../data/demo_recipient_3.pem"
]
recipients_perm = [
    # no permission restrictions
    "",
    # form filling and signing permissions granted, but not others
    "nomodify nocopy noannots noassemble",
    "nomodify nocopy noannots noassemble"
]
RECIPIENTCOUNT = len(recipients_cert)

if len(argv) != 3 :
    raise Exception("usage: certsec <infile> <outfile>" )

# create a new PLOP object
plop = PLOP()

try:
    optlist = "searchpath={%s}" % searchpath
    plop.set_option(optlist)

    # open unprotected input file
    doc = plop.open_document(argv[1], "")
    if (doc == -1):
        raise PLOPException("Error: %s" % plop.get_errmsg())

    # add recipients
    for r in range(0, RECIPIENTCOUNT, 1):
        optlist = "certificate={filename={%s}} permissions={%s}" % (recipients_cert[r], recipients_perm[r])
        if (plop.add_recipient(optlist) == -1):
            # emit warning and continue
            print("Error: %s\n" % plop.get_errmsg());

    # create protected output file
    optlist = "input={%d}" % doc
    if (plop.create_document(argv[2], optlist) == -1):
        raise PLOPException("Error: %s" % plop.get_errmsg())

    plop.close_document(doc, "")

except PLOPException:
    print("PDFlib PLOP exception occurred:\n[%d] %s: %s" %
        ((plop.get_errnum()), plop.get_apiname(), plop.get_errmsg()))
    print_tb(exc_info()[2])

except Exception:
    print("Exception occurred: %s" % (exc_info()[0]))
    print_tb(exc_info()[2])

finally:
    plop.delete()
